% Code Author: Moh Sabbir Saadat
% Institution: University of South Carolina
% Last update date: September 24, 2021
% Website: https://cse.sc.edu/~msaadat/

% evaluate temperature & throughput
current_temp = idle_temp;
stat = false([no_antenna, 1]);
throughput_series = [];
temp_series = [];
transmit_time = [];
for j = 1:exp_window
    disp(strcat('...for slot: ', num2str(j), '...'))
    % transmitting
    transmit_time = [transmit_time tx_time(aquilo_schedule(j), j)+1]; % tx_time is a (no_antenna x exp_window) array
    frac = transmit_time(j) - floor(transmit_time(j));
    % throughput
    stat(aquilo_schedule(j)) = true;
    thr_profile = throughput_profile(:, aquilo_schedule(j));
    throughput = sum(thr_profile(1:floor(transmit_time(j))));
    diff_thr = (frac/2)*(thr_profile(floor(transmit_time(j)))+thr_profile(ceil(transmit_time(j))));
    throughput = throughput + diff_thr;
    throughput_series  = [throughput_series, throughput/transmit_time(j)];
    % temperature
    temp_prof = base_profile(:, aquilo_schedule(j)) + current_temp(aquilo_schedule(j));
    current_temp(aquilo_schedule(j)) = temp_prof(floor(transmit_time(j)));
    diff_temp = frac*(temp_prof(ceil(transmit_time(j)))-temp_prof(floor(transmit_time(j))));
    current_temp(aquilo_schedule(j)) = current_temp(aquilo_schedule(j)) + diff_temp;
    
    % dissipating
    % dissipating - {1:4}-ant_sched(j)
    for m = 1:no_antenna
        if m ~= aquilo_schedule(j)
            if stat(m)
                temp_prof = base_profile(:, m)-base_profile(tx_max, m);
                temp_prof(1:tx_max) = [];
                temp_prof = temp_prof + current_temp(m);
                current_temp(m) = temp_prof(floor(transmit_time(j)));
                diff_temp = frac*(temp_prof(ceil(transmit_time(j))) - temp_prof(floor(transmit_time(j))));
                current_temp(m) = current_temp(m) + diff_temp;
            end
        end
    end
    
    temp_series = [temp_series; current_temp];
end

% add the beam latency
transmit_time = transmit_time + (beam_latency/1000)*beam_search;
total_transmit_time = sum(transmit_time);
throughput_schedule = sum(throughput_series.*transmit_time)/total_transmit_time;
