% check if the code is running on windows or linux/mac
if ispc
    slash = '\';
else
    slash = '/';
end

% directories
folder_data = strcat('..', slash, 'data', slash, 'v1.0', slash);
folder_dissipation = strcat(folder_data, slash, 'single_transmission', slash); 
folder_currentdissipation = strcat(folder_data, 'current_dissipation_data', slash); % temporary directory
folder_scheduling = strcat(folder_data, 'scheduling_data', slash); % temporary directory
folder_output = strcat('..', slash, 'output');

% constants
exp_window = 10; 
no_antenna = 4; 
block_prob = 0.2; % increase this to simulate a more blocking environment 
data_length = 220;
tx_max = 15; % we have output for transmission times of 5, 10, 15 and 20 in ../data/v1.0/single_transmission/ directory
slot_length = 10;
if slot_length >= tx_max
    fprintf('Set slot length less than tx_max. \n');
    return;
end
no_dataFiles = 10; % we have this many data files for each tx period
% full_latency shows the fast beam alignment (AgileLink) delay and IEEE802.11ad beam alignmet delay 
% Data taken from 
% Haitham Hassanieh, Omid Abari, Michael Rodriguez, Mohammed Abdelghany, Dina Katabi, and Piotr Indyk. 2018. 
% Fast millimeter wave beam alignment. 
% In Proceedings of the 2018 Conference of the ACM Special Interest Group on Data Communication (SIGCOMM '18). 
% Association for Computing Machinery, New York, NY, USA, 432–445. DOI:https://doi.org/10.1145/3230543.3230581
full_latency = [0.51, 0.44, 1.27, 1.20; % for phase array size 8: first two- fast beam alignment; next two- IEEE802.11ad
    1.01, 0.51, 2.53, 1.26; % for phase array size 16: first two- fast beam alignment; next two- IEEE802.11ad
    2.02, NaN, 5.06, NaN; % interpolated: for phase array size 32: first two- fast beam alignment; next two- IEEE802.11ad
    4.04, 0.89, 304.04, 2.40]; % for phase array size 64: first two- fast beam alignment; next two- IEEE802.11ad
