% Code Author: Moh Sabbir Saadat
% Institution: University of South Carolina
% Last update date: September 24, 2021
% Website: https://cse.sc.edu/~msaadat/

% begin scheduling
disp('Probe and switch in each slot...')
beam_search = zeros(1, exp_window);
aquilo_schedule = [];
emp = false;
for i = 1:exp_window
    disp(strcat('...for slot: ', num2str(i), '...'))
    current_antenna = sorted_schedules(1, 1);
    beam_search(i) = beam_search(i) + 1;
    
    % keep the current sorted schedule list in a temporary variable
    % this will help in recouping the original list in the event that
    % all available antennas are blocked except the previous one
    temporary_schedules = sorted_schedules;
    empty_set = false;
    
    while channel_status(i, current_antenna) == 0
        % We check whether there is only one row in the
        % sorted_schedules matrix; if true - concatanate this row to
        % adaptive schedule
        if size(sorted_schedules, 1) == 1
            disp('ONLY ONE POSSIBLE SCHEDULE')
            aquilo_schedule = [aquilo_schedule, sorted_schedules];
            emp = true;
            break;
        else
            
            idx = find(sorted_schedules(:,1) == current_antenna);
            for j = 1:length(idx)
                % eliminate the rows
                sorted_schedules(idx(j),:) = [];
                idx = idx -1;
                
                % if all the antennas except the last one is blocked
                if isempty(sorted_schedules)
                    disp('EMPTY ANTENNA SET')
                    empty_set = true;
                    sorted_schedules = temporary_schedules;
                    current_antenna = aquilo_schedule(i-1);
                    beam_search(i) = beam_search(i) + 4;
                    
                    break;
                end
            end
            
            if ~empty_set
                current_antenna = sorted_schedules(1, 1);
                beam_search(i) = beam_search(i) + 1;
            end
        end
    end
    
    if ~emp
        aquilo_schedule = [aquilo_schedule, current_antenna];
        % eliminate the columns
        sorted_schedules(:,1) = [];
    else
        break;
    end
end
