% MATLAB script to visualize each data file
% Only change the parameters, on_period and off_period 
% to change the pulse width and duty cycle
% Author: Moh Sabbir Saadat, University of South Carolina
% Date: September 03, 2020

clear all; close all; clc; 

addpath('../parse_functions') % contains the functions to parse the binary files

% change these two parameters
on_period = 10; 
off_period = 5; 

filename = strcat('exp_client_on', num2str(on_period), '_off', num2str(off_period));

throughput = ExtractThroughput(strcat(filename, '_bf'));
temperature = ExtractTemperature(strcat(filename, '_temp'));

% throughput plot
figure; plot(throughput, 'LineWidth', 2)
grid on
xlabel('Time (s)')
ylabel('Throughput (Mbps)')
title(strcat('Pulsed Transmission with ', num2str(on_period), 's on period and ', num2str(off_period), 's off period'))

% temperature plot
figure; plot(temperature, 'LineWidth', 2)
grid on
xlabel('Time (s)')
ylabel('Temperature (^{\circ}C)')
title(strcat('Pulsed Transmission with ', num2str(on_period), 's on period and ', num2str(off_period), 's off period'))