% MATLAB script to visualize each data file
% Only change the parameters, on_period and off_period 
% to change the pulse width and duty cycle
% Author: Moh Sabbir Saadat, University of South Carolina
% Date: September 03, 2020

clear all; close all; clc; 

addpath('../parse_functions') % contains the functions to parse the binary files

% change these two parameters
on_period = 10; 
trial = 9; 

filename = strcat('dissipation', '_',num2str(on_period), '_', num2str(trial));

throughput = ExtractThroughput(strcat(filename, '_bf'));
temperature = ExtractTemperature(strcat(filename, '_temp'));

% throughput plot
figure; plot(throughput, 'LineWidth', 2)
grid on
xlabel('Time (s)')
ylabel('Throughput (Mbps)')
title(strcat('Transmission Period = ', num2str(on_period), 's'))

% temperature plot
figure; plot(temperature, 'LineWidth', 2)
grid on
xlabel('Time (s)')
ylabel('Temperature (^{\circ}C)')
title(strcat('Transmission Period = ', num2str(on_period), 's'))